/* $Id: preview.h,v 1.9 2000/09/14 06:07:14 acapnotic Exp $ */

#ifndef _PREVIEW_H_
#define _PREVIEW_H_

#include <gtk/gtk.h>
#ifndef _GLACE_H_
#  include "glace.h"
#endif

#include "output.h" /* for doing an out_revision */

/* Single preview */

GlaceGimpPreview* ace_preview_new            (GlaceGimpData*          wData);

void              ace_preview_update         (Glace_ClientData*       clientData);

void              ace_preview_update_finished(GlaceGimpPreview*       preview);

gboolean          ace_preview_smart_update   (Glace_ClientData*       clientData,
					      guint                   revision,
					      guint                   out_revision);

void              ace_preview_fill_from_source(const Glace_ClientData* clientData);

void              ace_preview_cancel         (GlaceGimpPreview*       preview);

void              ace_preview_progress_update(const GlaceGimpPreview* preview,
					      gfloat                  percentage);

AcePreviewState   ace_preview_get_state      (const GlaceGimpPreview* preview);

void              ace_preview_set_state      (GlaceGimpPreview*       preview, 
					      AcePreviewState state);

/* Manyview */

ManyviewMatrix*   manyview_matrix_new       (const GlaceGimpDrawableInfo* drawable_info);

void              manyview_register_adjustment(ManyviewMatrix* manyview,
					       GtkAdjustment* adjustment);

void              manyview_look_alive       (ManyviewMatrix* manyview);

void              manyview_set_geometry     (Glace_ClientData* clientData, 
					     int               view_x0, 
					     int               view_y0,
					     int               view_width, 
					     int               view_height);

gboolean          manyview_smart_update     (ManyviewMatrix* manyview_matrix, 
					     guint revision, 
					     guint out_revision);

struct _GlaceGimpPreview
{
  guint16 bpp;

  guint idle_handle;
  gint idle_priority; /* This is subtracted from G_PRIORITY_DEFAULT_IDLE */
  GTimer* timeout_timer;

  GtkPreview*        preview;
  GtkPreview*        grayview;

  GtkProgress*       pbar;
  AcePreviewState    state;

  GtkScrolledWindow* scrollwin;
};

struct _ManyviewMatrix
{
  Glace_ClientData* clients[3][3];
  
  GtkAdjustment* x_axis;
  GtkAdjustment* y_axis;
  GtkAdjustment* xdelta;
  GtkAdjustment* ydelta;

  GtkWidget* tablewidget;   /* The table which the manyview is displayed in. */
  GtkWidget* xlabels[3];    /* Labels along the axes */
  GtkWidget* ylabels[3];

  gfloat xvalues[3];
  gfloat yvalues[3];

  GtkMenu* xmenu;
  GtkMenu* ymenu;

  /* Viewfinder */
  GtkWidget* viewfinder;
  GtkAdjustment* view_x;
  GtkAdjustment* view_y;
};

/* The default minimum preview size. */
#define PREVIEW_WIDTH  84
#define PREVIEW_HEIGHT 63

/* Used by the viewfinder. */
#define NAV_PREVIEW_SIZE 112
#define BORDER_PEN_WIDTH 3

/* The progress bar mostly counts by iterations, but there are some other
   chunks to count too. */
#define PROG_INPUT_CHUNKS  1
#define PROG_OUTPUT_CHUNKS 2
#define PROG_OCHUNKS (PROG_INPUT_CHUNKS + PROG_OUTPUT_CHUNKS)

#endif /* _PREVIEW_H_ */

/* For emacs:
Local Variables:
mode:c
c-file-style:"gnu"
End:
*/
