/* $Id: types.h,v 1.7 2000/09/09 22:09:53 acapnotic Exp $ */

#ifndef _GLACEGIMP_TYPES_H_
#define _GLACEGIMP_TYPES_H_

#include <libgimp/gimp.h>
#ifdef DIAGNOSTIC
# include <gtk/gtk.h>
#endif

typedef unsigned char PreviewPixel;
typedef unsigned char GimpPixel;
typedef gint32 GimpDrawableID;

typedef enum {
  PREVIEW_IDLE,
  PREVIEW_WORKING
} AcePreviewState;

typedef struct _GlaceGimpPreview GlaceGimpPreview;
typedef struct _GlaceGimpDrawableInfo GlaceGimpDrawableInfo;

typedef struct _ManyviewMatrix ManyviewMatrix;


/* We need just one instance of this for the drawable we're working with. */
struct _GlaceGimpDrawableInfo
{
  GimpDrawable *drawable; /* structure for the drawable we're using. */

  gint32 x0, y0; /* Upper-left corner of the selection, in drawable coords. */
  gint32 w, h;

  gboolean has_alpha;

  GimpPixel *gimpImgPtr; /* This is a buffer for the source pixel region. */

  guint gimpImgSize;
  guint gimpImgRowstride;

  /* The extracted grayscale channel. */
  guchar* inImgPtr;
  guint inImgSize;
};

/* Mnemonics for GTK */
#define EXPAND (TRUE)
#define FILL (TRUE)
#define RESIZE (TRUE)
#define SHRINK (TRUE)
#define HOMOG (TRUE)

#endif /* _GLACEGIMP_TYPES_H_ */

/* For emacs:
Local Variables:
mode:c
c-file-style:"gnu"
End:
*/
