/*********************************************************************************/
/* LIC 0.50 -- image filter plug-in for The Gimp program                         */
/* Copyright (C) 2001/02 Frank Lauterwald                                        */
/*===============================================================================*/
/* E-mail: frankl@gmx.net                                                        */
/* You can contact the original The Gimp authors at gimp@xcf.berkeley.edu        */
/*===============================================================================*/
/* This program is free software; you can redistribute it and/or modify it under */
/* the terms of the GNU General Public License as published by the Free Software */
/* Foundation; either version 2 of the License, or (at your option) any later    */
/* version.                                                                      */
/*===============================================================================*/
/* This program is distributed in the hope that it will be useful, but WITHOUT   */
/* ANY WARRANTY; without even the implied warranty of MERCHANTABILITY or FITNESS */
/* FOR A PARTICULAR PURPOSE. See the GNU General Public License for more details.*/
/*===============================================================================*/
/* You should have received a copy of the GNU General Public License along with  */
/* this program; if not, write to the Free Software Foundation, Inc., 675 Mass   */
/* Ave, Cambridge, MA 02139, USA.                                                */
/*===============================================================================*/
/* In other words, you can't sue me for whatever happens while using this ;)     */
/*********************************************************************************/
/* CHANGELOG									 */
/* Date		Version		Comment						 */
/* 2001 Oct. 1,    0.30		first "release"					 */
/* 2002 Jan. 26,   0.50		release of first beta version			 */
/*********************************************************************************/

/* Prototypes for lic_algorithm_include.c only */
void algorithm_lic_euler_compute_pixel_rgb_blockfilter(gint block_x, gint block_y, gint global_x, gint global_y);
void algorithm_lic_euler_compute_pixel_rgba_blockfilter(gint block_x, gint block_y, gint global_x, gint global_y);
void algorithm_lic_euler_compute_pixel_gray_blockfilter(gint block_x, gint block_y, gint global_x, gint global_y);
void algorithm_lic_euler_compute_pixel_graya_blockfilter(gint block_x, gint block_y, gint global_x, gint global_y);
void algorithm_dda_euler_compute_pixel_rgb_blockfilter(gint block_x, gint block_y, gint global_x, gint global_y);
void algorithm_dda_euler_compute_pixel_rgba_blockfilter(gint block_x, gint block_y, gint global_x, gint global_y);
void algorithm_dda_euler_compute_pixel_gray_blockfilter(gint block_x, gint block_y, gint global_x, gint global_y);
void algorithm_dda_euler_compute_pixel_graya_blockfilter(gint block_x, gint block_y, gint global_x, gint global_y);
void algorithm_lic_euler_compute_pixel_rgb_anyfilter(gint block_x, gint block_y, gint global_x, gint global_y);
void algorithm_lic_euler_compute_pixel_rgba_anyfilter(gint block_x, gint block_y, gint global_x, gint global_y);
void algorithm_lic_euler_compute_pixel_gray_anyfilter(gint block_x, gint block_y, gint global_x, gint global_y);
void algorithm_lic_euler_compute_pixel_graya_anyfilter(gint block_x, gint block_y, gint global_x, gint global_y);
void algorithm_dda_euler_compute_pixel_rgb_anyfilter(gint block_x, gint block_y, gint global_x, gint global_y);
void algorithm_dda_euler_compute_pixel_rgba_anyfilter(gint block_x, gint block_y, gint global_x, gint global_y);
void algorithm_dda_euler_compute_pixel_gray_anyfilter(gint block_x, gint block_y, gint global_x, gint global_y);
void algorithm_dda_euler_compute_pixel_graya_anyfilter(gint block_x, gint block_y, gint global_x, gint global_y);

void algorithm_lic_euler_compute_pixel_rgb_anyfilter_noise(gint block_x, gint block_y, gint global_x, gint global_y);
void algorithm_lic_euler_compute_pixel_rgba_anyfilter_noise(gint block_x, gint block_y, gint global_x, gint global_y);
void algorithm_lic_euler_compute_pixel_gray_anyfilter_noise(gint block_x, gint block_y, gint global_x, gint global_y);
void algorithm_lic_euler_compute_pixel_graya_anyfilter_noise(gint block_x, gint block_y, gint global_x, gint global_y);
void algorithm_dda_euler_compute_pixel_rgb_anyfilter_noise(gint block_x, gint block_y, gint global_x, gint global_y);
void algorithm_dda_euler_compute_pixel_rgba_anyfilter_noise(gint block_x, gint block_y, gint global_x, gint global_y);
void algorithm_dda_euler_compute_pixel_gray_anyfilter_noise(gint block_x, gint block_y, gint global_x, gint global_y);
void algorithm_dda_euler_compute_pixel_graya_anyfilter_noise(gint block_x, gint block_y, gint global_x, gint global_y);


void algorithm_lic_cabral_compute_pixel_rgb_blockfilter(gint block_x, gint block_y, gint global_x, gint global_y);
void algorithm_lic_cabral_compute_pixel_rgba_blockfilter(gint block_x, gint block_y, gint global_x, gint global_y);
void algorithm_lic_cabral_compute_pixel_gray_blockfilter(gint block_x, gint block_y, gint global_x, gint global_y);
void algorithm_lic_cabral_compute_pixel_graya_blockfilter(gint block_x, gint block_y, gint global_x, gint global_y);
void algorithm_dda_cabral_compute_pixel_rgb_blockfilter(gint block_x, gint block_y, gint global_x, gint global_y);
void algorithm_dda_cabral_compute_pixel_rgba_blockfilter(gint block_x, gint block_y, gint global_x, gint global_y);
void algorithm_dda_cabral_compute_pixel_gray_blockfilter(gint block_x, gint block_y, gint global_x, gint global_y);
void algorithm_dda_cabral_compute_pixel_graya_blockfilter(gint block_x, gint block_y, gint global_x, gint global_y);
void algorithm_lic_cabral_compute_pixel_rgb_anyfilter(gint block_x, gint block_y, gint global_x, gint global_y);
void algorithm_lic_cabral_compute_pixel_rgba_anyfilter(gint block_x, gint block_y, gint global_x, gint global_y);
void algorithm_lic_cabral_compute_pixel_gray_anyfilter(gint block_x, gint block_y, gint global_x, gint global_y);
void algorithm_lic_cabral_compute_pixel_graya_anyfilter(gint block_x, gint block_y, gint global_x, gint global_y);
void algorithm_dda_cabral_compute_pixel_rgb_anyfilter(gint block_x, gint block_y, gint global_x, gint global_y);
void algorithm_dda_cabral_compute_pixel_rgba_anyfilter(gint block_x, gint block_y, gint global_x, gint global_y);
void algorithm_dda_cabral_compute_pixel_gray_anyfilter(gint block_x, gint block_y, gint global_x, gint global_y);
void algorithm_dda_cabral_compute_pixel_graya_anyfilter(gint block_x, gint block_y, gint global_x, gint global_y);
