/*********************************************************************************/
/* LIC 0.50 -- image filter plug-in for The Gimp program                         */
/* Copyright (C) 2001/02 Frank Lauterwald                                        */
/*===============================================================================*/
/* E-mail: frankl@gmx.net                                                        */
/* You can contact the original The Gimp authors at gimp@xcf.berkeley.edu        */
/*===============================================================================*/
/* This program is free software; you can redistribute it and/or modify it under */
/* the terms of the GNU General Public License as published by the Free Software */
/* Foundation; either version 2 of the License, or (at your option) any later    */
/* version.                                                                      */
/*===============================================================================*/
/* This program is distributed in the hope that it will be useful, but WITHOUT   */
/* ANY WARRANTY; without even the implied warranty of MERCHANTABILITY or FITNESS */
/* FOR A PARTICULAR PURPOSE. See the GNU General Public License for more details.*/
/*===============================================================================*/
/* You should have received a copy of the GNU General Public License along with  */
/* this program; if not, write to the Free Software Foundation, Inc., 675 Mass   */
/* Ave, Cambridge, MA 02139, USA.                                                */
/*===============================================================================*/
/* In other words, you can't sue me for whatever happens while using this ;)     */
/*********************************************************************************/
/* CHANGELOG									 */
/* Date		Version		Comment						 */
/* 2001 Oct. 1,    0.30		first "release"					 */
/* 2002 Jan. 26,   0.50		release of first beta version			 */
/*********************************************************************************/

#ifndef __lic_color__
#define __lic_color__

#include <libgimp/gimp.h>
typedef gfloat (*ColorConversionFunction)(void* p) ;

gfloat get_rgb_red(void *p);
gfloat get_rgb_green(void *p);
gfloat get_rgb_blue(void *p);
gfloat get_rgb_brightness(void *p);
gfloat get_rgb_saturation(void* p);
gfloat get_rgb_hue(void* p);
gfloat get_gray_brightness(void* v);
#define get_gray_red get_gray_brightness
#define get_gray_green get_gray_brightness
#define get_gray_blue get_gray_brightness
gfloat get_gray_saturation(void* v);
gfloat get_gray_hue(void* v);

typedef struct {
	guchar r,g,b;
} rgbpixel;

typedef struct {
	guchar r,g,b,a;
} rgbapixel;

typedef struct {
	guchar b;
} graypixel;

typedef struct {
	guchar a0, a1;
} grayapixel;


typedef struct {
	gfloat r,g,b;
} rgbfloatpixel;

typedef struct {
	gfloat r,g,b,a;
} rgbafloatpixel;

typedef struct {
	gfloat b;
} grayfloatpixel;

typedef struct {
	gfloat a0, a1;
} grayafloatpixel;

extern const rgbfloatpixel  RGBFLOATPIXEL_BLACK;
extern const grayfloatpixel GRAYFLOATPIXEL_BLACK;

#endif
