/*********************************************************************************/
/* LIC 0.50 -- image filter plug-in for The Gimp program                         */
/* Copyright (C) 2001/02 Frank Lauterwald                                        */
/*===============================================================================*/
/* E-mail: frankl@gmx.net                                                        */
/* You can contact the original The Gimp authors at gimp@xcf.berkeley.edu        */
/*===============================================================================*/
/* This program is free software; you can redistribute it and/or modify it under */
/* the terms of the GNU General Public License as published by the Free Software */
/* Foundation; either version 2 of the License, or (at your option) any later    */
/* version.                                                                      */
/*===============================================================================*/
/* This program is distributed in the hope that it will be useful, but WITHOUT   */
/* ANY WARRANTY; without even the implied warranty of MERCHANTABILITY or FITNESS */
/* FOR A PARTICULAR PURPOSE. See the GNU General Public License for more details.*/
/*===============================================================================*/
/* You should have received a copy of the GNU General Public License along with  */
/* this program; if not, write to the Free Software Foundation, Inc., 675 Mass   */
/* Ave, Cambridge, MA 02139, USA.                                                */
/*===============================================================================*/
/* In other words, you can't sue me for whatever happens while using this ;)     */
/*********************************************************************************/
/* CHANGELOG									 */
/* Date		Version		Comment						 */
/* 2001 Oct. 1,    0.30		first "release"					 */
/* 2002 Jan. 26,   0.50		release of first beta version			 */
/*********************************************************************************/

#ifndef __lic_vectors__
#define __lic_vectors__


#include <stdio.h>
#include <stdlib.h>

#include <gdk/gdk.h>
#include <gtk/gtk.h>
#include <libgimp/gimp.h>
#include <libgimp/gimpui.h>
#include <libgimp/gimptypes.h>
#include <glib.h>

#define IS_NULLVECTOR(a) (a==0?TRUE:FALSE)
#define NULLVECTOR	0

typedef struct
{ gfloat x,y; } floatvector;

typedef struct
{ floatvector *field; } lic_floatvector_field;

typedef struct
{ int     width;
  int     height;
  guint16 *data; } lic_vector_by_index_field;

typedef struct {
	gint32 width, height;
	gfloat* data;
} lic_scalarfield;


lic_scalarfield *lic_create_scalarfield(gint32 sourceimageid);
void lic_create_floatvector_field(lic_floatvector_field *f);
guint16 get_vector_index_from_vector(floatvector f);
void rotate_vector_by_index_field(lic_vector_by_index_field *f, guint16 angle_as_int);
lic_vector_by_index_field *lic_create_vectors(gint32 sourceimageid);

#endif
