#ifdef HAVE_CONFIG_H
#  include <config.h>
#endif

// !CHANGE
//#include <gnome.h>

#include "callbacks.h"
#include "interface.h"
#include "support.h"

// !CHANGE
#include "../lic_globals.h"
#include "lic_userinterface.h"


void
on_radio_effectchannel_toggled         (GtkToggleButton *togglebutton,
                                        gpointer         user_data)
{
	guint value = (guint)user_data;
	parameters.options.effectchannel=value;
	userinterface_set_statusbar("Effect channel successfully changed");
}

// !CHANGE - what was this meant to be ?
/*GtkWidget*
gtk_adjustment_new_ (gchar *widget_name, gchar *string1, gchar *string2,
                gint int1, gint int2)
{

}*/


void
on_button_main_ok_clicked              (GtkButton       *button,
                                        gpointer         user_data)
{
   // get the filtercurve into our variables

   gtk_curve_get_vector(GTK_CURVE(GTK_GAMMA_CURVE(userinterface_get_widget("curve_filtercurve"))->curve), FILTERCURVE_NUMBER_OF_POINTS, variables.otherfilter_points);

/* note in variables that it was cancel that was clicked	*/
   variables.ok_or_cancel=CLICK_OK;
   /* destroy the widget	*/
   gtk_main_quit();
   gtk_widget_destroy(user_data);
}


void
on_button_main_cancel_clicked          (GtkButton       *button,
                                        gpointer         user_data)
{
/* note in variables that it was cancel that was clicked	*/
   variables.ok_or_cancel=CLICK_CANCEL;
   gtk_main_quit();
   gtk_widget_destroy(user_data);
}


void
on_check_create_newimage_toggled       (GtkToggleButton *togglebutton,
                                        gpointer         user_data)
{
	if (parameters.options.createNewImage)
	{	parameters.options.createNewImage=FALSE;
		userinterface_set_statusbar("No new image will be created");
	}
	else
	{	parameters.options.createNewImage=TRUE;
		userinterface_set_statusbar("New image will be created");
	}
}


void
on_button_preset_default_clicked       (GtkButton       *button,
                                        gpointer         user_data)
{
	parameters.options.getTextureFrom = GETTEXTUREFROM_IMAGE;
	//parameters.options.effectchannel  = EFFECTCHANNEL_BRIGHTNESS;
	parameters.options.rotateVectors  = TRUE;
	parameters.filterfunction.filterfunction = FILTERFUNCTION_BOX;
	parameters.algorithm.algorithm = ALGORITHM_LICCABRAL;

	userinterface_set_values();
	userinterface_set_statusbar("Default values set");
}


void
on_button_preset_emulation_clicked     (GtkButton       *button,
                                        gpointer         user_data)
{
	parameters.options.getTextureFrom = GETTEXTUREFROM_IMAGE;
	//parameters.options.effectchannel  = EFFECTCHANNEL_BRIGHTNESS;
	parameters.options.rotateVectors  = FALSE;
	parameters.filterfunction.filterfunction = FILTERFUNCTION_TRIANGLE;
	parameters.algorithm.algorithm = ALGORITHM_DDAEULER;
	parameters.algorithm.extras.ddaEuler.stepsize = C_DEFAULTSTEPSIZE;

	userinterface_set_values();
	userinterface_set_statusbar("Values set to emulate Tom's filter");
}


void
on_radio_method_lic_toggled            (GtkToggleButton *togglebutton,
                                        gpointer         user_data)
{
	if ( (parameters.algorithm.algorithm==ALGORITHM_DDACABRAL) ) {
		parameters.algorithm.algorithm = ALGORITHM_LICCABRAL;
	} else {
		parameters.algorithm.algorithm = ALGORITHM_LICEULER;
	}
	userinterface_set_statusbar("method changed to LIC");
}


void
on_radio_method_dda_toggled            (GtkToggleButton *togglebutton,
                                        gpointer         user_data)
{
	if ( (parameters.algorithm.algorithm==ALGORITHM_LICCABRAL) ) {
		parameters.algorithm.algorithm = ALGORITHM_DDACABRAL;
	} else {
		parameters.algorithm.algorithm = ALGORITHM_DDAEULER;
	}
	userinterface_set_statusbar("method changed to DDA");
}


void
on_radio_algorithm_euler_toggled       (GtkToggleButton *togglebutton,
                                        gpointer         user_data)
{
	// change to euler is always possible as euler can do everything
	if ( (parameters.algorithm.algorithm==ALGORITHM_DDACABRAL) ) {
		parameters.algorithm.algorithm = ALGORITHM_DDAEULER;
	} else {
		parameters.algorithm.algorithm = ALGORITHM_LICEULER;
	}
	userinterface_set_statusbar("algorithm changed to Euler");
}


void
on_radio_algorithm_cabral_toggled      (GtkToggleButton *togglebutton,
                                        gpointer         user_data)
{
	// change to cabral may fail:
	// gettexturefrom must be image. This will not be changed but cause an error message
	// filter must not be other. error message too
	if ( (parameters.algorithm.algorithm==ALGORITHM_DDAEULER) ) {
		if (parameters.options.getTextureFrom == GETTEXTUREFROM_NOISE) {
			userinterface_set_value_algorithm();
			userinterface_set_statusbar("Cabral cannot be used when 'Convolve with noise' is selected");
			return;
		}
		if (parameters.filterfunction.filterfunction==FILTERFUNCTION_OTHER) {
			userinterface_set_value_algorithm();
			userinterface_set_statusbar("Cabral cannot be used with 'other filter'");
			return;
		}
		parameters.algorithm.algorithm = ALGORITHM_DDACABRAL;
		userinterface_set_statusbar("algorithm changed to Cabral");
	} else {
		if (parameters.options.getTextureFrom == GETTEXTUREFROM_NOISE) {
			userinterface_set_value_algorithm();
			userinterface_set_statusbar("Cabral cannot be used when 'Convolve with noise' is selected");
			return;
		}
		if (parameters.filterfunction.filterfunction==FILTERFUNCTION_OTHER) {
			userinterface_set_value_algorithm();
			userinterface_set_statusbar("Cabral cannot be used with 'other filter'");
			return;
		}
		parameters.algorithm.algorithm = ALGORITHM_LICCABRAL;
		userinterface_set_statusbar("algorithm changed to Cabral");
	}
}


void
on_radio_filter_toggled                (GtkToggleButton *togglebutton,
                                        gpointer         user_data)
{
	gint ff = (gint) (user_data);
	if ( (ff == FILTERFUNCTION_OTHER) &&
		( (parameters.algorithm.algorithm == ALGORITHM_DDACABRAL) ||
		  (parameters.algorithm.algorithm == ALGORITHM_LICCABRAL) )) {
		userinterface_set_values();
		userinterface_set_statusbar("'other filter' cannot be used with 'Cabral' algorithm. Use 'Euler' instead");
		return;
	}
	parameters.filterfunction.filterfunction = ff;
	userinterface_set_value_filtercurve();
	userinterface_set_statusbar("filterfunction successfully changed");
}


void on_radio_rotatevectors_toggled    (GtkToggleButton *togglebutton,
                                        gpointer         user_data)
{
	if ((gint) user_data != 0) {
		parameters.options.rotateVectors = TRUE;
		userinterface_set_statusbar("Vectors will be rotated");
	} else {
		parameters.options.rotateVectors = FALSE;
		userinterface_set_statusbar("Vectors will not be rotated");
	}
}

// !CHANGE what was this meant to be?
/*
GtkWidget*
gtk_adjustment_new (gchar *widget_name, gchar *string1, gchar *string2,
                gint int1, gint int2)
{

}*/

void on_radio_convolvewith_image_toggled    (GtkToggleButton *togglebutton,
					gpointer         user_data) {
	parameters.options.getTextureFrom = GETTEXTUREFROM_IMAGE;
	userinterface_set_statusbar("Convolution is done with source image");
}

void on_radio_convolvewith_noise_toggled    (GtkToggleButton *togglebutton,
					gpointer         user_data) {
	if ( (parameters.algorithm.algorithm==ALGORITHM_DDACABRAL) ||  (parameters.algorithm.algorithm==ALGORITHM_LICCABRAL)) {
		userinterface_set_value_convolvewith();
		userinterface_set_statusbar("'Cabral' cannot convolve with noise. Use 'Euler'");
		return;
	}
	parameters.options.getTextureFrom = GETTEXTUREFROM_NOISE;
	userinterface_set_statusbar("Convolution is done with white noise");
}

// !CHANGE added those five functions. re-creating the source with glade should add those too ...
void on_filterlength_changed		(GtkAdjustment   *adj,
                                         gpointer         user_data) {
	parameters.filterlength = adj->value;
	userinterface_set_statusbar("");
}

void on_noisemagnitude_changed		(GtkAdjustment   *adj,
                                         gpointer         user_data) {
	parameters.noiseoptions.magnitude = adj->value;
	userinterface_set_statusbar("");
}

void on_minv_changed			(GtkAdjustment   *adj,
                                         gpointer         user_data) {
	parameters.noiseoptions.minv = adj->value;
	userinterface_set_statusbar("");

}

void on_maxv_changed			(GtkAdjustment   *adj,
                                         gpointer         user_data) {
	parameters.noiseoptions.maxv = adj->value;
	userinterface_set_statusbar("");
}

void on_stepsize_changed		(GtkAdjustment   *adj,
                                         gpointer         user_data) {
	parameters.algorithm.extras.ddaEuler.stepsize = adj->value;
	userinterface_set_statusbar("");
}


// !CHANGE added those two functions because Glade doesn't know drawable-option-menus
gboolean effect_image_constrain(gint32 image_id , gint32 drawable_id, gpointer data)
{ /* FIXME: at the moment we allow just any texture image. dont know if this is correct	*/
  return TRUE;
}


void effect_image_callback(gint32 id, gpointer data)
{
  parameters.options.vectorImageDrawable = id;
  userinterface_set_statusbar("effect image successfully changed");
}

