/*********************************************************************************/
/* LIC 0.50 -- image filter plug-in for The Gimp program                         */
/* Copyright (C) 2001/02 Frank Lauterwald                                        */
/*===============================================================================*/
/* E-mail: frankl@gmx.net                                                        */
/* You can contact the original The Gimp authors at gimp@xcf.berkeley.edu        */
/*===============================================================================*/
/* This program is free software; you can redistribute it and/or modify it under */
/* the terms of the GNU General Public License as published by the Free Software */
/* Foundation; either version 2 of the License, or (at your option) any later    */
/* version.                                                                      */
/*===============================================================================*/
/* This program is distributed in the hope that it will be useful, but WITHOUT   */
/* ANY WARRANTY; without even the implied warranty of MERCHANTABILITY or FITNESS */
/* FOR A PARTICULAR PURPOSE. See the GNU General Public License for more details.*/
/*===============================================================================*/
/* You should have received a copy of the GNU General Public License along with  */
/* this program; if not, write to the Free Software Foundation, Inc., 675 Mass   */
/* Ave, Cambridge, MA 02139, USA.                                                */
/*===============================================================================*/
/* In other words, you can't sue me for whatever happens while using this ;)     */
/*********************************************************************************/
/* Changes (post 0.01):                                                          */
/* 2002 Jan. 26,   0.50		release of first beta version			 */
/*********************************************************************************/

#include <libgimp/gimpui.h>

/* this function will show the window for user interface stuff 	*/
/* Thus the user can set parameters				*/
void show_userinterface();

/* this function sets all adjustable widgets to appropriate values
 * Think of a button selects a preset for all adjustable option.
 * If you press it, all widgets showing these options must be
 * informed to display the new values.
 * This can be done by calling this function.
 * DANGER: call this only from callbacks of widgets which are not in turn changed
 * by this function or infinite loops may be caused
 */
void userinterface_set_values();


/* this function sets a statusbar text
 * Every action in the UI (i.e. each callback function)
 * That does not have anything to report (i.e. no problems)
 * Shall set the statusbar to "" to make sure that an error
 * message doesnt hang around all day
 */
void userinterface_set_statusbar(gchar *text);


/* this is a wrapper function for glades lookup_widget
 * the only thing it does is call lookup_widget(window_mainwindow, name)
 * Thus we need not make window_mainwindow global
 */
GtkWidget *userinterface_get_widget(gchar *name);
