/*  Physically Modeled Media Plug-In for The GIMP
 *  Copyright (c) 2000-2001 David A. Bartold
 *
 *  This program is free software; you can redistribute it and/or modify
 *  it under the terms of the GNU General Public License as published by
 *  the Free Software Foundation; either version 2 of the License, or
 *  (at your option) any later version.
 *
 *  This program is distributed in the hope that it will be useful,
 *  but WITHOUT ANY WARRANTY; without even the implied warranty of
 *  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 *  GNU General Public License for more details.
 *
 *  You should have received a copy of the GNU General Public License
 *  along with this program; if not, write to the Free Software
 *  Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA
 */

#include <gtk/gtk.h>


GtkWidget*
create_color_palette (gchar *widget_name, gchar *string1, gchar *string2,
                gint int1, gint int2);

GtkWidget*
create_color_pencil (gchar *widget_name, gchar *string1, gchar *string2,
                gint int1, gint int2);

gboolean
on_color_pencil_button_press_event     (GtkWidget       *widget,
                                        GdkEventButton  *event,
                                        gpointer         user_data);

gboolean
on_color_pencil_motion_notify_event    (GtkWidget       *widget,
                                        GdkEventMotion  *event,
                                        gpointer         user_data);

void
on_clear_clicked                       (GtkButton       *button,
                                        gpointer         user_data);

GtkWidget*
create_texture_preview (gchar *widget_name, gchar *string1, gchar *string2,
                gint int1, gint int2);

void
on_grain_toggled                       (GtkToggleButton *togglebutton,
                                        gpointer         user_data);

void
on_texture_ok_clicked                  (GtkButton       *button,
                                        gpointer         user_data);

void
on_pencil_ok_clicked                   (GtkButton       *button,
                                        gpointer         user_data);

void
on_color_sel_ok_clicked                (GtkButton       *button,
                                        gpointer         user_data);

void
on_color_sel_cancel_clicked            (GtkButton       *button,
                                        gpointer         user_data);

GtkWidget*
create_color_area (gchar *widget_name, gchar *string1, gchar *string2,
                gint int1, gint int2);

void
on_sky_ok_clicked                      (GtkButton       *button,
                                        gpointer         user_data);

void
on_sky_generate_preview_clicked        (GtkButton       *button,
                                        gpointer         user_data);

GtkWidget*
create_sky_preview (gchar *widget_name, gchar *string1, gchar *string2,
                gint int1, gint int2);

void
on_show_sun_toggled                    (GtkToggleButton *togglebutton,
                                        gpointer         user_data);

GtkWidget*
create_color_picker (gchar *widget_name, gchar *string1, gchar *string2,
                gint int1, gint int2);
