/*  Physically Modeled Media Plug-In for The GIMP
 *  Copyright (c) 2000-2001 David A. Bartold
 *
 *  This program is free software; you can redistribute it and/or modify
 *  it under the terms of the GNU General Public License as published by
 *  the Free Software Foundation; either version 2 of the License, or
 *  (at your option) any later version.
 *
 *  This program is distributed in the hope that it will be useful,
 *  but WITHOUT ANY WARRANTY; without even the implied warranty of
 *  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 *  GNU General Public License for more details.
 *
 *  You should have received a copy of the GNU General Public License
 *  along with this program; if not, write to the Free Software
 *  Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA
 */

#ifndef __GTK_RGB_AREA_H__
#define __GTK_RGB_AREA_H__


#include <gtk/gtkdrawingarea.h>

#ifdef __cplusplus
extern "C" {
#endif /* __cplusplus */

#define GTK_TYPE_RGB_AREA            (gtk_rgb_area_get_type ())
#define GTK_RGB_AREA(obj)            (GTK_CHECK_CAST ((obj), GTK_TYPE_RGB_AREA, GtkRgbArea))
#define GTK_RGB_AREA_CLASS(klass)    (GTK_CHECK_CLASS_CAST ((klass), GTK_TYPE_RGB_AREA, GtkRgbAreaClass))
#define GTK_IS_RGB_AREA(obj)         (GTK_CHECK_TYPE ((obj), GTK_TYPE_RGB_AREA))
#define GTK_IS_RGB_AREA_CLASS(klass) (GTK_CHECK_CLASS_TYPE ((klass), GTK_TYPE_RGB_AREA))

typedef struct _GtkRgbArea      GtkRgbArea;
typedef struct _GtkRgbAreaClass GtkRgbAreaClass;

struct _GtkRgbArea
{
  GtkDrawingArea parent;

  GdkRectangle   dirty;

  gint           width;
  gint           height;
  guint8        *rgb_data;
};

struct _GtkRgbAreaClass
{
  GtkDrawingAreaClass parent_class;
};

GtkType    gtk_rgb_area_get_type   (void);
GtkWidget* gtk_rgb_area_new        (void);
void       gtk_rgb_area_invalidate (GtkRgbArea *area,
                                    gint        x,
                                    gint        y,
                                    gint        width,
                                    gint        height);
void       gtk_rgb_area_soft_sync  (GtkRgbArea *area);
void       gtk_rgb_area_hard_sync  (GtkRgbArea *area);


#ifdef __cplusplus
}
#endif /* __cplusplus */


#endif /* __GTK_RGB_AREA_H__ */
